function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { Entity, Index, JoinColumn, Column, PrimaryColumn, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export let GalleryPost = class GalleryPost {
    id;
    createdAt;
    updatedAt;
    title;
    description;
    userId;
    user;
    fileIds;
    isSensitive;
    likedCount;
    tags;
    constructor(data){
        if (data == null) return;
        for (const [k, v] of Object.entries(data)){
            this[k] = v;
        }
    }
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], GalleryPost.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the GalleryPost."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], GalleryPost.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The updated date of the GalleryPost."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], GalleryPost.prototype, "updatedAt", void 0);
_ts_decorate([
    Column("varchar", {
        length: 256
    }),
    _ts_metadata("design:type", String)
], GalleryPost.prototype, "title", void 0);
_ts_decorate([
    Column("varchar", {
        length: 2048,
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], GalleryPost.prototype, "description", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The ID of author."
    }),
    _ts_metadata("design:type", Object)
], GalleryPost.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], GalleryPost.prototype, "user", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        array: true,
        default: "{}"
    }),
    _ts_metadata("design:type", Array)
], GalleryPost.prototype, "fileIds", void 0);
_ts_decorate([
    Index(),
    Column("boolean", {
        default: false,
        comment: "Whether the post is sensitive."
    }),
    _ts_metadata("design:type", Boolean)
], GalleryPost.prototype, "isSensitive", void 0);
_ts_decorate([
    Index(),
    Column("integer", {
        default: 0
    }),
    _ts_metadata("design:type", Number)
], GalleryPost.prototype, "likedCount", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 128,
        array: true,
        default: "{}"
    }),
    _ts_metadata("design:type", Array)
], GalleryPost.prototype, "tags", void 0);
GalleryPost = _ts_decorate([
    Entity(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [
        typeof Partial === "undefined" ? Object : Partial
    ])
], GalleryPost);
